# Copyright (C) 2009-2010 Gloobus Developers
#
#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

import logging
import gtk
import os

from urllib2 import quote
from urllib2 import urlopen
from xml.dom import minidom
from gettext import gettext as _

from core import config
from core.common import CACHE_PATH
from lyrics import GenericLyric

c = logging.getLogger(__name__)

URL_TEMPLATE = "http://api.lyricsfly.com/api/api.php?i=%s&a=%s&t=%s"

class lyricsfly(GenericLyric):

    __title__ = 'LyricsFly'
    __version__ = '0.1.1'
    __authors__ = 'Jaap Broekhuizen <jaapz.b@gmail.com>, Jordi Hernandez <guitarboy000@gmail.com>'
    __desc__ = _('Download lyrics from LyricsFly.com')

    url = ''

    def get(self, artist, title):
        key = config.get('Lyrics', 'lyricsfly_key')
        artist = quote(artist.encode('utf-8'))
        title = quote(title.encode('utf-8'))

        self.url = URL_TEMPLATE % (key, artist, title)
        c.debug('LyricsFly URL: ' + self.url)

        try:
            content = urlopen(self.url).read()
            xml = minidom.parseString(content)
            lyric = xml.getElementsByTagName("tx")[0].childNodes[0].nodeValue
            lyric = lyric.replace('\n', '').replace('[br]', '\n')
            return lyric
        except:
            pass
        return None

    def get_webpage(self):
        self.url

    @staticmethod
    def configure(dialog):
        vbox = dialog.get_content_area()
        vbox.set_border_width(10)
        vbox.set_size_request(350, -1)

        box = gtk.HBox(False, 10)
        label = gtk.Label(_('API key') + ':')
        label.set_alignment(0,0.5)
        key = gtk.Entry()
        key.set_text(config.get('Lyrics', 'lyricsfly_key'))
        box.pack_start(label, False)
        box.pack_start(key, True)
        vbox.pack_start(box, False)

        vbox.show_all()

        if dialog.run() == gtk.RESPONSE_ACCEPT:
            config.get('Lyrics', 'lyricsfly_key', key.get_text())
