# Copyright (C) 2009-2010 Gloobus Developers
#
#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

import logging
import re

from urllib2 import quote
from urllib2 import urlopen

from lyrics import GenericLyric

c = logging.getLogger(__name__)

# site not working anymore,
# if starts working uncomment next line and comment one after it
#class lyricsplugin(GenericLyric):
class lyricsplugin():

    __title__ = 'LyricsPlugin.com'
    __version__ = '0.1'
    __authors__ = 'Alexandr Grigorcea <cahr.gr@gmail.com>'
    __desc__ = 'API to load lyricsplugin.com lyrics'

    url = ""

    def get( self , artist, song):
        artist = self.prepare(artist, True)
        song = self.prepare(song)

        self.url = "http://www.lyricsplugin.com/wmplayer03/plugin/?artist="+artist+"&title="+song
        c.debug('lyricsplugin URL: ' + self.url)
        try:
            content = urlopen(self.url).read()
            regexp = re.compile ('<div.+?id="lyrics".*?>(.*?)</div>',re.DOTALL)
            m = regexp.search(content)
            if m:
                lyric =  m.group(1)
                regexp = re.compile ('\s*?<br\s*?/>\s*',re.DOTALL)
                lyric = regexp.sub('\n', lyric).strip()
                if lyric:
                    return lyric
        except:
            pass
        return None

    def prepare(self, s, artist=False):
        s = s.decode('utf-8')
        if not artist:
            s = re.sub('[\[\(]\s*(live|bonus|feat|ft).*?[\]\)]', '', s)
        s = quote(s.encode('utf-8'))
        return s

    def get_webpage(self):
        return self.url
